## pytables 3.3.0

=== requirements.txt ===
# Keep in sync with tables/req_versions.py and
# doc/source/usersguide/installation.rst
numpy>=1.8.0
numexpr>=2.5.2
six

=== c-blosc/blosc/CMakeLists.txt ===
# a simple way to detect that we are using CMAKE
add_definitions(-DUSING_CMAKE)

set(INTERNAL_LIBS ${CMAKE_SOURCE_DIR}/internal-complibs)

# Hide symbols by default unless they're specifically exported.
# This makes it easier to keep the set of exported symbols the
# same across all compilers/platforms.
set(CMAKE_C_VISIBILITY_PRESET hidden)

# includes
if(NOT DEACTIVATE_LZ4)
    if (LZ4_FOUND)
        include_directories( ${LZ4_INCLUDE_DIR} )
    else(LZ4_FOUND)
        set(LZ4_LOCAL_DIR ${INTERNAL_LIBS}/lz4-1.7.2)
        include_directories( ${LZ4_LOCAL_DIR} )
    endif(LZ4_FOUND)
endif(NOT DEACTIVATE_LZ4)

if(NOT DEACTIVATE_SNAPPY)
    if (SNAPPY_FOUND)
        include_directories( ${SNAPPY_INCLUDE_DIR} )
    else(SNAPPY_FOUND)
        set(SNAPPY_LOCAL_DIR ${INTERNAL_LIBS}/snappy-1.1.1)
        include_directories( ${SNAPPY_LOCAL_DIR} )
    endif(SNAPPY_FOUND)
endif(NOT DEACTIVATE_SNAPPY)

if(NOT DEACTIVATE_ZLIB)
    if (ZLIB_FOUND)
        include_directories( ${ZLIB_INCLUDE_DIR} )
    else(ZLIB_FOUND)
        set(ZLIB_LOCAL_DIR ${INTERNAL_LIBS}/zlib-1.2.8)
        include_directories( ${ZLIB_LOCAL_DIR} )
    endif(ZLIB_FOUND)
endif(NOT DEACTIVATE_ZLIB)

if (NOT DEACTIVATE_ZSTD)
    if (ZSTD_FOUND)
        include_directories(${ZSTD_INCLUDE_DIR})
    else (ZSTD_FOUND)
        set(ZSTD_LOCAL_DIR ${INTERNAL_LIBS}/zstd-1.0.0)
        include_directories(${ZSTD_LOCAL_DIR} ${ZSTD_LOCAL_DIR}/common)
    endif (ZSTD_FOUND)
endif (NOT DEACTIVATE_ZSTD)

# library sources
set(SOURCES blosc.c blosclz.c shuffle-generic.c bitshuffle-generic.c)
if(COMPILER_SUPPORT_SSE2)
    message(STATUS "Adding run-time support for SSE2")
    set(SOURCES ${SOURCES} shuffle-sse2.c bitshuffle-sse2.c)
endif(COMPILER_SUPPORT_SSE2)
if(COMPILER_SUPPORT_AVX2)
    message(STATUS "Adding run-time support for AVX2")
    set(SOURCES ${SOURCES} shuffle-avx2.c bitshuffle-avx2.c)
endif(COMPILER_SUPPORT_AVX2)
set(SOURCES ${SOURCES} shuffle.c)

# library install directory
set(lib_dir lib${LIB_SUFFIX})
set(version_string ${BLOSC_VERSION_MAJOR}.${BLOSC_VERSION_MINOR}.${BLOSC_VERSION_PATCH})

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
if(WIN32)
    # try to use the system library
    find_package(Threads)
    if(NOT Threads_FOUND)
        message(STATUS "using the internal pthread library for win32 systems.")
        set(SOURCES ${SOURCES} win32/pthread.c)
    else(NOT Threads_FOUND)
        set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
    endif(NOT Threads_FOUND)
else(WIN32)
    find_package(Threads REQUIRED)
    set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
endif(WIN32)

if(NOT DEACTIVATE_LZ4)
    if(LZ4_FOUND)
        set(LIBS ${LIBS} ${LZ4_LIBRARY})
    else(LZ4_FOUND)
        file(GLOB LZ4_FILES ${LZ4_LOCAL_DIR}/*.c)
        set(SOURCES ${SOURCES} ${LZ4_FILES})
    endif(LZ4_FOUND)
endif(NOT DEACTIVATE_LZ4)

if(NOT DEACTIVATE_SNAPPY)
    if(SNAPPY_FOUND)
        set(LIBS ${LIBS} ${SNAPPY_LIBRARY})
    else(SNAPPY_FOUND)
        file(GLOB SNAPPY_FILES ${SNAPPY_LOCAL_DIR}/*.cc)
        set(SOURCES ${SOURCES} ${SNAPPY_FILES})
    endif(SNAPPY_FOUND)
endif(NOT DEACTIVATE_SNAPPY)

if(NOT DEACTIVATE_ZLIB)
    if(ZLIB_FOUND)
        set(LIBS ${LIBS} ${ZLIB_LIBRARY})
    else(ZLIB_FOUND)
        file(GLOB ZLIB_FILES ${ZLIB_LOCAL_DIR}/*.c)
        set(SOURCES ${SOURCES} ${ZLIB_FILES})
    endif(ZLIB_FOUND)
endif(NOT DEACTIVATE_ZLIB)

if (NOT DEACTIVATE_ZSTD)
    if (ZSTD_FOUND)
        set(LIBS ${LIBS} ${ZSTD_LIBRARY})
    else (ZSTD_FOUND)
      file(GLOB ZSTD_FILES
        ${ZSTD_LOCAL_DIR}/common/*.c
        ${ZSTD_LOCAL_DIR}/compress/*.c
        ${ZSTD_LOCAL_DIR}/decompress/*.c)
        set(SOURCES ${SOURCES} ${ZSTD_FILES})
    endif (ZSTD_FOUND)
endif (NOT DEACTIVATE_ZSTD)

# targets
add_library(blosc_shared SHARED ${SOURCES})
set_target_properties(blosc_shared PROPERTIES OUTPUT_NAME blosc)
set_target_properties(blosc_shared PROPERTIES
        VERSION ${version_string}
        SOVERSION 1  # Change this when an ABI change happens
    )
set_property(
    TARGET blosc_shared
    APPEND PROPERTY COMPILE_DEFINITIONS BLOSC_SHARED_LIBRARY)

# Based on the target architecture and hardware features supported
# by the C compiler, set hardware architecture optimization flags
# for specific shuffle implementations.
if(COMPILER_SUPPORT_SSE2)
    if (MSVC)
        # MSVC targets SSE2 by default on 64-bit configurations, but not 32-bit configurations.
        if (${CMAKE_SIZEOF_VOID_P} EQUAL 4)
            set_source_files_properties(shuffle-sse2.c bitshuffle-sse2.c PROPERTIES COMPILE_FLAGS "/arch:SSE2")
        endif (${CMAKE_SIZEOF_VOID_P} EQUAL 4)
    else (MSVC)
        set_source_files_properties(shuffle-sse2.c bitshuffle-sse2.c PROPERTIES COMPILE_FLAGS -msse2)
    endif (MSVC)

    # Define a symbol for the shuffle-dispatch implementation
    # so it knows SSE2 is supported even though that file is
    # compiled without SSE2 support (for portability).
    set_property(
        SOURCE shuffle.c
        APPEND PROPERTY COMPILE_DEFINITIONS SHUFFLE_SSE2_ENABLED)
endif(COMPILER_SUPPORT_SSE2)
if(COMPILER_SUPPORT_AVX2)
    if (MSVC)
        set_source_files_properties(shuffle-avx2.c bitshuffle-avx2.c PROPERTIES COMPILE_FLAGS "/arch:AVX2")
    else (MSVC)
        set_source_files_properties(shuffle-avx2.c bitshuffle-avx2.c PROPERTIES COMPILE_FLAGS -mavx2)
    endif (MSVC)

    # Define a symbol for the shuffle-dispatch implementation
    # so it knows AVX2 is supported even though that file is
    # compiled without AVX2 support (for portability).
    set_property(
        SOURCE shuffle.c
        APPEND PROPERTY COMPILE_DEFINITIONS SHUFFLE_AVX2_ENABLED)
endif(COMPILER_SUPPORT_AVX2)

# When the option has been selected to compile the test suite,
# compile an additional version of blosc_shared which exports
# some normally-hidden symbols (to facilitate unit testing).
if (BUILD_TESTS)
    add_library(blosc_shared_testing SHARED ${SOURCES})
    set_target_properties(blosc_shared_testing PROPERTIES OUTPUT_NAME blosc_testing)
    set_property(
        TARGET blosc_shared_testing
        APPEND PROPERTY COMPILE_DEFINITIONS BLOSC_SHARED_LIBRARY)
    set_property(
        TARGET blosc_shared_testing
        APPEND PROPERTY COMPILE_DEFINITIONS BLOSC_TESTING)
    # TEMP : CMake doesn't automatically add -lpthread here like it does
    # for the blosc_shared target. Force it for now.
    if(UNIX)
        set_property(
            TARGET blosc_shared_testing
            APPEND PROPERTY LINK_FLAGS "-lpthread")
    endif()
endif()

target_link_libraries(blosc_shared ${LIBS})
if (BUILD_TESTS)
    target_link_libraries(blosc_shared_testing ${LIBS})
endif()

if(BUILD_STATIC)
    add_library(blosc_static STATIC ${SOURCES})
    set_target_properties(blosc_static PROPERTIES OUTPUT_NAME blosc)
    if (MSVC)
        set_target_properties(blosc_static PROPERTIES PREFIX lib)
    endif()
    target_link_libraries(blosc_static ${LIBS})
endif(BUILD_STATIC)


# install
install(FILES blosc.h blosc-export.h DESTINATION include COMPONENT DEV)
install(TARGETS blosc_shared DESTINATION ${lib_dir} COMPONENT LIB)
if(BUILD_STATIC)
    install(TARGETS blosc_static DESTINATION ${lib_dir} COMPONENT DEV)
endif(BUILD_STATIC)

=== debian/changelog ===
pytables (3.3.0-5) unstable; urgency=medium

  * debian/rules
    - typo in BUILD_DATE
  * debian/patches
    - removed 0006-Disable-tests-on-bitshuffle.patch
      It is no longer necessary after the fix of #844047 in
      c-blosc 1.11.1+ds1-3
    - new 0006-allow-for-long-type-in-nextafter.patch.
      Imported from upstream  (see also
      https://github.com/PyTables/PyTables/pull/587)
    - new 0007-fix-base-class-order.patch to fix compatibility with
      Python v2.7.13.
      See also https://github.com/PyTables/PyTables/issues/590

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Wed, 07 Dec 2016 13:19:56 +0100

pytables (3.3.0-4) unstable; urgency=medium

  * debian/patches
    - new 0006-Disable-tests-on-bitdhuffle.patch: temporarily disable
      tests on the blosc bitshuffle filter due to bug #843040

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Thu, 03 Nov 2016 18:13:31 +0000

pytables (3.3.0-3) unstable; urgency=medium

  * debian/patches
    - improved 0005-Ignore-cpuinfo-on-unsupported-archs.patch to ignore
      any kind of error from cpuinfo

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Tue, 01 Nov 2016 21:35:06 +0000

pytables (3.3.0-2) unstable; urgency=medium

  * debian/patches
    - new 0005-Ignore-cpuinfo-on-unsupported-archs.patch:
      fix build on non x86 platforms

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Tue, 01 Nov 2016 08:10:06 +0000

pytables (3.3.0-1) unstable; urgency=medium

  * New upstream release
  * Use packaged blosc library
  * debian/watch
    - add compatibility to the new tagging schema
  * debian/patches
    - drop 0005-fix-index-inheritance-order.patch and
      0006-fix-typo-in-hdf5extension.pyx.patch: applied upstream
    - new 0005-fix-compatibility-with-HDF5-1.10.patch
    - drop 0002-Use-system-compression-libs.patch: not necessary
    - refresh all patches
  * debian/copyright
    - add copyright for zsrd source
  * debian/rules
    - set hardening flags
  * debian/control
    - cleanup and warning suppression
    - add build dependency from python?-six

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Mon, 31 Oct 2016 14:34:18 +0000

pytables (3.2.2-3) unstable; urgency=medium
  * debian/control
    - standard version bumped to 3.9.8 (no change required)
    - fix build dependencies: add missing texlive-generic-extra
      (Closes: #829077)
  * debian/copyright
    - fix DEP-5 url

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 02 Jul 2016 09:52:51 +0000

=== debian/control ===
Source: pytables
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Antonio Valentino <antonio.valentino@tiscali.it>,
           Yaroslav Halchenko <debian@onerussian.com>
Section: python
Testsuite: autopkgtest
Priority: optional
Build-Depends: debhelper (>= 9.0.0),
               dh-python,
               locales,
               libhdf5-dev,
               python-all-dev,
               python-all-dbg,
               python3-all-dev,
               python3-all-dbg,
               python-setuptools,
               python3-setuptools,
               python-six,
               python3-six,
               python-numpy,
               python-numpy-dbg,
               python3-numpy,
               python3-numpy-dbg,
               python-numexpr,
               python-numexpr-dbg,
               python3-numexpr,
               python3-numexpr-dbg,
               cython,
               cython-dbg,
               cython3,
               cython3-dbg,
               zlib1g-dev,
               liblzo2-dev,
               libblosc-dev,
               liblz4-dev (>= 0.0~r122),
               libsnappy-dev,
               libbz2-dev,
               libzstd-dev,
               python-sphinx,
               texlive-generic-extra,
               texlive-latex-recommended,
               texlive-latex-extra,
               texlive-fonts-recommended,
               libjs-jquery-cookie
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/pytables.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/pytables.git
Homepage: http://www.pytables.org
X-Python-Version: >= 2.6
X-Python3-Version: >= 3.2

Package: python-tables
Architecture: all
Depends: ${misc:Depends},
         ${python:Depends},
         python-tables-lib (>= ${source:Version}),
         python-tables-lib (<< ${source:Version}.1~),
         python-tables-data (= ${source:Version}),
         python-numexpr
Suggests: python-tables-doc,
          python-netcdf,
          vitables
Description: hierarchical database for Python based on HDF5
 PyTables is a hierarchical database package designed to efficiently
 manage very large amounts of data. PyTables is built on top of the
 HDF5 library and the NumPy package. It features an object-oriented
 interface that, combined with natural naming and C-code generated
 from Pyrex sources, makes it a fast, yet extremely easy to use tool
 for interactively save and retrieve large amounts of data.
 .
  - Compound types (records) can be used entirely from Python (i.e. it
    is not necessary to use C for taking advantage of them).
  - The tables are both enlargeable and compressible.
  - I/O is buffered, so you can get very fast I/O, specially with
    large tables.
  - Very easy to select data through the use of iterators over the
    rows in tables. Extended slicing is supported as well.
  - It supports the complete set of NumPy, Numeric and numarray objects.
 .
 This is the Python 2 version of the package.

Package: python-tables-lib
Architecture: any
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: python-tables (= ${source:Version})
Breaks: python-tables (<< 3.0.0-3)
Replaces: python-tables (<< 3.0.0-3)
Description: hierarchical database for Python based on HDF5 (extension)
 PyTables is a hierarchical database package designed to efficiently
 manage very large amounts of data. PyTables is built on top of the
 HDF5 library and the NumPy package. It features an object-oriented
 interface that, combined with natural naming and C-code generated
 from Pyrex sources, makes it a fast, yet extremely easy to use tool
 for interactively save and retrieve large amounts of data.
 .
  - Compound types (records) can be used entirely from Python (i.e. it
    is not necessary to use C for taking advantage of them).
  - The tables are both enlargeable and compressible.
  - I/O is buffered, so you can get very fast I/O, specially with
    large tables.
  - Very easy to select data through the use of iterators over the
    rows in tables. Extended slicing is supported as well.
  - It supports the complete set of NumPy, Numeric and numarray objects.
 .
 This package contains the extension built for the Python 2 interpreter.

Package: python-tables-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
         python-tables (= ${source:Version}),
         python-tables-lib (= ${binary:Version}),
         python-dbg,
         python-numpy-dbg,
         python-numexpr-dbg
Suggests: python-tables-doc,
          python-netcdf
Description: hierarchical database for Python based on HDF5 (debug extension)
 PyTables is a hierarchical database package designed to efficiently
 manage very large amounts of data. PyTables is built on top of the
 HDF5 library and the NumPy package. It features an object-oriented
 interface that, combined with natural naming and C-code generated
 from Pyrex sources, makes it a fast, yet extremely easy to use tool
 for interactively save and retrieve large amounts of data.
 .
  - Compound types (records) can be used entirely from Python (i.e. it
    is not necessary to use C for taking advantage of them).
  - The tables are both enlargeable and compressible.
  - I/O is buffered, so you can get very fast I/O, specially with
    large tables.
  - Very easy to select data through the use of iterators over the
    rows in tables. Extended slicing is supported as well.
  - It supports the complete set of NumPy, Numeric and numarray objects.
 .
 This package contains the extension built for the Python 2 debug interpreter.

Package: python3-tables
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
         python3-tables-lib (>= ${source:Version}),
         python3-tables-lib (<< ${source:Version}.1~),
         python-tables-data (= ${source:Version}),
         python3-numexpr
Suggests: python-tables-doc,
          python-netcdf,
          vitables
Description: hierarchical database for Python3 based on HDF5
 PyTables is a hierarchical database package designed to efficiently
 manage very large amounts of data. PyTables is built on top of the
 HDF5 library and the NumPy package. It features an object-oriented
 interface that, combined with natural naming and C-code generated
 from Pyrex sources, makes it a fast, yet extremely easy to use tool
 for interactively save and retrieve large amounts of data.
 .
  - Compound types (records) can be used entirely from Python (i.e. it
    is not necessary to use C for taking advantage of them).
  - The tables are both enlargeable and compressible.
  - I/O is buffered, so you can get very fast I/O, specially with
    large tables.
  - Very easy to select data through the use of iterators over the
    rows in tables. Extended slicing is supported as well.
  - It supports the complete set of NumPy, Numeric and numarray objects.
 .
 This is the Python 3 version of the package.

Package: python3-tables-lib
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-tables (= ${source:Version})
Breaks: python3-tables (<< 3.0.0-3)
Replaces: python3-tables (<< 3.0.0-3)
Description: hierarchical database for Python3 based on HDF5 (extension)
 PyTables is a hierarchical database package designed to efficiently
 manage very large amounts of data. PyTables is built on top of the
 HDF5 library and the NumPy package. It features an object-oriented
 interface that, combined with natural naming and C-code generated
 from Pyrex sources, makes it a fast, yet extremely easy to use tool
 for interactively save and retrieve large amounts of data.
 .
  - Compound types (records) can be used entirely from Python (i.e. it
    is not necessary to use C for taking advantage of them).
  - The tables are both enlargeable and compressible.
  - I/O is buffered, so you can get very fast I/O, specially with
    large tables.
  - Very easy to select data through the use of iterators over the
    rows in tables. Extended slicing is supported as well.
  - It supports the complete set of NumPy, Numeric and numarray objects.
 .
 This package contains the extension built for the Python 3 interpreter.

Package: python3-tables-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         python3-tables (= ${source:Version}),
         python3-tables-lib (= ${binary:Version}),
         python3-dbg,
         python3-numpy-dbg,
         python3-numexpr-dbg
Suggests: python-tables-doc,
          python-netcdf
Description: hierarchical database for Python 3 based on HDF5 (debug extension)
 PyTables is a hierarchical database package designed to efficiently
 manage very large amounts of data. PyTables is built on top of the
 HDF5 library and the NumPy package. It features an object-oriented
 interface that, combined with natural naming and C-code generated
 from Pyrex sources, makes it a fast, yet extremely easy to use tool
 for interactively save and retrieve large amounts of data.
 .
  - Compound types (records) can be used entirely from Python (i.e. it
    is not necessary to use C for taking advantage of them).
  - The tables are both enlargeable and compressible.
  - I/O is buffered, so you can get very fast I/O, specially with
    large tables.
  - Very easy to select data through the use of iterators over the
    rows in tables. Extended slicing is supported as well.
  - It supports the complete set of NumPy, Numeric and numarray objects.
 .
 This package contains the extension built for the Python 3 debug interpreter.

Package: python-tables-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-jquery-cookie
Suggests: xpdf | pdf-viewer,
          www-browser
Description: hierarchical database for Python based on HDF5 - documentation
 PyTables is a hierarchical database package designed to efficiently
 manage very large amounts of data. PyTables is built on top of the
 HDF5 library and the NumPy package. It features an object-oriented
 interface that, combined with natural naming and C-code generated
 from Pyrex sources, makes it a fast, yet extremely easy to use tool
 for interactively save and retrieve large amounts of data.
 .
 This package includes the manual in PDF and HTML formats.

Package: python-tables-data
Architecture: all
Depends: ${misc:Depends}
Description: hierarchical database for Python based on HDF5 - test data
 PyTables is a hierarchical database package designed to efficiently
 manage very large amounts of data. PyTables is built on top of the
 HDF5 library and the NumPy package. It features an object-oriented
 interface that, combined with natural naming and C-code generated
 from Pyrex sources, makes it a fast, yet extremely easy to use tool
 for interactively save and retrieve large amounts of data.
 .
 This package includes daya fils used for unit testing.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie

# Get the supported Python versions
PY2VERS = $(shell pyversions -r -v)
PY3VERS = $(shell py3versions -r -v)

LAST_CHANGE=$(shell dpkg-parsechangelog -S Date)
BUILD_DATE=$(shell LC_ALL=C date -u "+%B %d, %Y" -d "$(LAST_CHANGE)")
SPHINXOPTS := -D today=\"$(BUILD_DATE)\"
SPHINXOPTS += -D html_last_updated_fmt=\"$(BUILD_DATE)\"

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
export CFLAGS ?= -O0
endif

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
  export HDF5_DIR := /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
endif

%:
	dh $@ --with python2,python3,sphinxdoc --buildsystem=python_distutils


build-python%:
	python$* setup.py build
	python$*-dbg setup.py build


override_dh_auto_build: $(PY3VERS:%=build-python%)
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) PWD=$(CURDIR) SPHINXOPTS="$(SPHINXOPTS)"
	$(MAKE) -C doc PWD=$(CURDIR) SPHINXOPTS="$(SPHINXOPTS)" latexpdf
	mv doc/build/latex/usersguide-*.pdf doc/usersguide.pdf
else
	$(MAKE) ANNOUNCE.txt
	$(MAKE) -C src all
	mkdir -p doc/html
	touch doc/usersguide.pdf
endif
	dh_auto_build --buildsystem=python_distutils


install-python%:
	python$* setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb
	python$*-dbg setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb


override_dh_auto_install: $(PY3VERS:%=install-python%)
	dh_auto_install


override_dh_install:
	# Install everything excluding the *.so extensions to python(3)-tables
	dh_install -X"*.so" -X"*.h5" -X"*.xbm" -X"*.dat" -X"*.mat" "debian/tmp/usr/lib/python2*" -p python-tables
	dh_install -X"*.so" -X"*.h5" -X"*.xbm" -X"*.dat" -X"*.mat" "debian/tmp/usr/lib/python3*" -p python3-tables

	# Install the extensions to python(3)-tables-lib
	dh_install -X"*_d.so" "debian/tmp/usr/lib/python2*/*-packages/tables/*.so" -p python-tables-lib
	find debian/python-tables-lib -name '*_d.so' | xargs -r rm -f
	dh_install -X"*dmu.so" -X"*dm.so" "debian/tmp/usr/lib/python3*/*-packages/tables/*.so" -p python3-tables-lib
	find debian/python3-tables-lib -name '*.cpython-??dm-*.so' | xargs -r rm -f

	# Install the debug extensions to python(3)-tables-dbg
	dh_install "debian/tmp/usr/lib/python2*/*-packages/tables/*_d.so" -p python-tables-dbg
	dh_install "debian/tmp/usr/lib/python3*/*-packages/tables/*.cpython-??dm*.so" -p python3-tables-dbg

	# Continue with regular dh_install
	dh_install -p python-tables-doc
	dh_install -p python-tables-data

	# link data files
	for py in $(PY2VERS); do \
		for f in debian/tmp/usr/lib/python2*/*-packages/tables/tests/*.h5 \
		         debian/tmp/usr/lib/python2*/*-packages/tables/tests/*.mat; do \
			dh_link -p python-tables usr/share/python-tables/tests/$$(basename $$f) usr/lib/python$$py/dist-packages/tables/tests/$$(basename $$f); \
		done; \
		for f in debian/tmp/usr/lib/python2*/*-packages/tables/nodes/tests/*.h5 \
		         debian/tmp/usr/lib/python2*/*-packages/tables/nodes/tests/*.xbm \
		         debian/tmp/usr/lib/python2*/*-packages/tables/nodes/tests/*.dat; do \
			dh_link -p python-tables usr/share/python-tables/nodes/tests/$$(basename $$f) usr/lib/python$$py/dist-packages/tables/nodes/tests/$$(basename $$f); \
		done; \
	done

	for f in debian/tmp/usr/lib/python3*/*-packages/tables/tests/*.h5 \
	         debian/tmp/usr/lib/python3*/*-packages/tables/tests/*.mat; do \
		dh_link -p python3-tables usr/share/python-tables/tests/$$(basename $$f) usr/lib/python3/dist-packages/tables/tests/$$(basename $$f); \
	done
	for f in debian/tmp/usr/lib/python3*/*-packages/tables/nodes/tests/*.h5 \
	         debian/tmp/usr/lib/python3*/*-packages/tables/nodes/tests/*.xbm \
	         debian/tmp/usr/lib/python3*/*-packages/tables/nodes/tests/*.dat; do \
		dh_link -p python3-tables usr/share/python-tables/nodes/tests/$$(basename $$f) usr/lib/python3/dist-packages/tables/nodes/tests/$$(basename $$f); \
	done

	dh_numpy
	dh_numpy3
	# using override_dh_auto_test causes problems for dbg versions
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# https://github.com/PyTables/PyTables/issues/485
	mkdir -p $(CURDIR)/tmp-locales
	localedef -i /usr/share/i18n/locales/en_US -c -f UTF-8 \
		-A /usr/share/locale/locale.alias \
		$(CURDIR)/tmp-locales/en_US.UTF-8
	set -e -x; \
	for py in $(PY2VERS); do \
		cd $(CURDIR)/build/lib.*-$$py; \
		env PYTHONPATH=. \
			LOCPATH=$(CURDIR)/tmp-locales LC_ALL=en_US.UTF-8 \
			python$$py tables/tests/test_all.py -vvv; \
		cd $(CURDIR)/debian/tmp/usr/lib/python$$py/dist-packages; \
		env PYTHONPATH=. \
			LOCPATH=$(CURDIR)/tmp-locales LC_ALL=en_US.UTF-8 \
			python$$py-dbg tables/tests/test_all.py -vvv; \
	done
	set -e -x; \
	for py in $(PY3VERS); do \
		cd $(CURDIR)/build/lib.*-$$py; \
		env PYTHONPATH=. \
			LOCPATH=$(CURDIR)/tmp-locales LC_ALL=en_US.UTF-8 \
			python$$py tables/tests/test_all.py -vvv; \
		#cd $(CURDIR)/debian/tmp/usr/lib/python3/dist-packages; \
		#env PYTHONPATH=. \
		#	LOCPATH=$(CURDIR)/tmp-locales LC_ALL=en_US.UTF-8 \
		#	python$$py-dbg tables/tests/test_all.py -vvv; \
	done
endif


override_dh_auto_clean:
	# Avoid unnecessary cythonization (see
	# https://github.com/PyTables/PyTables/issues/122)
	#dh_auto_clean --buildsystem=python_distutils
	$(MAKE) distclean
	rm -f doc/*.pdf


override_dh_sphinxdoc:
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	dh_sphinxdoc -ppython-tables-doc
	rm -f $(CURDIR)/debian/python-tables-doc/usr/share/doc/python-tables-doc/html/_static/jquery.cookie.js
endif


override_dh_installchangelogs:
	dh_installchangelogs -k RELEASE_NOTES.txt


override_dh_compress:
	dh_compress -X.txt -X.pdf -X.py -X.h5


.PHONY: override_dh_auto_build override_dh_auto_install override_dh_auto_clean \
        override_dh_sphinxdoc override_dh_install \
        override_dh_installchangelogs override_dh_compress
